import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;
import java.net.*;

/**
 * This is little command line java proggie for receiving data over a 
 * java.nio TCP socket.  
 */
public class NIOReceive {
    public static void main(String args[])
    {
      try {
        Selector selector = Selector.open();
        InetSocketAddress isa = new InetSocketAddress(
            InetAddress.getLocalHost(), 999 );

        //Opening on address for listening.
        System.out.println("Binding server socket");
        ServerSocketChannel sc = ServerSocketChannel.open();
        sc.configureBlocking(false);
        sc.socket().bind(isa);
        sc.register(selector,SelectionKey.OP_ACCEPT);

        //select and handle events that come in
        System.out.println("Entering select loop");
        ByteBuffer ib = ByteBuffer.allocateDirect(5000);
        while( true ) {
            if( selector.select(5000) > 0 ) {
                Set keys = selector.selectedKeys();
                for( Iterator i = keys.iterator(); i.hasNext(); i.remove() ) {
                    SelectionKey key = (SelectionKey)i.next();

                    //handle accept events
                    if( key.isAcceptable() ) {
                        System.out.print("Got OP_ACCEPT event...");
                        if( sc != key.channel() )
                            throw new Exception("Wrong server channel");
                        SocketChannel c = (SocketChannel)sc.accept();
                        c.configureBlocking(false);
                        c.register(selector, SelectionKey.OP_READ);
                        String ip = c.socket().getInetAddress().
                            getHostAddress();
                        System.out.println("Connection accepted from "+ip);
                    }

                    //handle read events
                    if( key.isReadable() ) {
                        System.out.print("Got OP_READ event...");
                        SocketChannel c = (SocketChannel)key.channel();
                        String ip = c.socket().getInetAddress().
                            getHostAddress();
                        try {
                            int n = c.read(ib);
                            System.out.println("Read "+n+" bytes from "+ip);
                        } catch( IOException ex ) {
                            System.out.println("Disco from " + ip);
                            c.close();
                        }
                        ib.clear();
                    }
                }
            }
        }
      } catch (Exception ex) {
          System.out.println("---Exception occured---");
          ex.printStackTrace();
      }
    }
}
